
/*
hawk (Herv's awk) v1.0
Copyright (C) by Denis Valois && Cdric Llorens, 2008.
denis.valois@laposte.fr, cedric.llorens@wanadoo.fr

This software is a computer program whose purpose is to perform
pattern scanning and processing.  This is governed by a given
template containing patterns structured in regular expressions.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

#ifndef _IO_H
#define _IO_H

#include <stdio.h>

#ifndef BUF_INIT
#define BUF_INIT	BUFSIZ
#endif
#ifndef BUF_INCR
#define BUF_INCR	BUF_INIT
#endif

#define STDIN_FILENAME	"-"
#define STDIN_IMAGE	"<stdin>"

FILE *io_open(char *fn);
void io_close(FILE *fp, char *fn);

char *io_read(FILE *fp);		/* unbounded line read, returns NULL at EOF */

extern char *io_filename;		/* current file name */
extern char *io_line;			/* current line */
extern unsigned long io_lineno;		/* current line number */
extern unsigned long io_linelg;		/* current line length */

#endif
