
/*
hawk (Herv's awk) v1.0
Copyright (C) by Denis Valois && Cdric Llorens, 2008.
denis.valois@laposte.fr, cedric.llorens@wanadoo.fr

This software is a computer program whose purpose is to perform
pattern scanning and processing.  This is governed by a given
template containing patterns structured in regular expressions.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

#ifndef _SET_H
#define _SET_H


struct set_t
{
	unsigned long set_size;					/* governs compatibility (not essential) */
	unsigned long card;					/* set cardinality */
	char *set;						/* "bit" string [0 .. set_size - 1] */
	unsigned long *lst;					/* unordered list of elements [0 .. card - 1] */
};


void set_new(struct set_t *s, unsigned long set_size);		/* allocate set */
void set_free(struct set_t *s);

void set_reset(struct set_t *s);				/* make empty */
void set_add(struct set_t *s, unsigned long elem);		/* add elem in set s */
void set_swap(struct set_t *s1, struct set_t *s2);		/* permute s1 and s2 */
int set_equal(struct set_t *s1, struct set_t *s2);		/* s1 == s2 ? */

#endif
